diff -purN u-boot-1.0.0/cpu/arm925t/start.S u-boot-1.0.0-a/cpu/arm925t/start.S
--- u-boot-1.0.0/cpu/arm925t/start.S	Wed Sep 17 17:48:08 2003
+++ u-boot-1.0.0-a/cpu/arm925t/start.S	Mon Dec  1 12:13:01 2003
@@ -174,9 +174,9 @@ relocate:
 	/*
 	 * relocate armboot to RAM
 	 */
-	adr	r0, _start		/* r0 <- current position of code */
-	ldr	r2, _armboot_start
-	ldr	r3, _armboot_end
+	adr	r0, _start		/* r0, find addr of start (0 for 1510) */
+	ldr	r2, _armboot_start	/* get value of armboot start (text_base, sdram addr, ex 11f00000)*/
+	ldr	r3, _armboot_end	/* get end of text image */
 	sub	r2, r3, r2		/* r2 <- size of armboot */
 	ldr	r1, _TEXT_BASE		/* r1 <- destination address */
 	add	r2, r0, r2		/* r2 <- source end address */
@@ -223,7 +223,7 @@ cpu_init_crit:
 	mcr	p15, 0, r0, c8, c7, 0	/* flush v4 TLB */
 
 	/*
-	 * disable MMU stuff and caches
+	 * disable MMU stuff and enable i-cache
 	 */
 	mrc	p15, 0, r0, c1, c0, 0
 	bic	r0, r0, #0x00002300	@ clear bits 13, 9:8 (--V- --RS)
@@ -405,6 +405,17 @@ fiq:
 	bl 	do_fiq
 
 #endif
+	.align 5
+.global arm925_cache_flush
+arm925_cache_flush:
+		bic	r1, pc, #15             @ get current rounded address into r1
+		add	r2, r1, #16384		@ 2x the largest dcache size
+1:		ldr	r3, [r1], #16		@ s/w flush D cache
+		teq	r1, r2			@ are we done
+		bne	1b			@ loop if not done
+		mcr	p15, 0, r1, c7, c5, 0	@ invalidate I cache
+		mcr	p15, 0, r1, c7, c10, 4	@ drain WB
+		mov	pc, lr			@ back to caller
 
 	.align	5
 .globl reset_cpu
diff -purN u-boot-1.0.0/lib_arm/cache.c u-boot-1.0.0-a/lib_arm/cache.c
--- u-boot-1.0.0/lib_arm/cache.c	Mon Dec  1 12:10:11 2003
+++ u-boot-1.0.0-a/lib_arm/cache.c	Mon Dec  1 12:09:31 2003
@@ -21,9 +21,10 @@
  * MA 02111-1307 USA
  */
 
-/* for now: just dummy functions to satisfy the linker */
-
 void  flush_cache (unsigned long dummy1, unsigned long dummy2)
 {
+#ifdef CONFIG_OMAP1510
+	arm925_cache_flush();
+#endif
 	return;
 }
